#include <stdio.h>      /* for printf() and fprintf() */
#include <sys/socket.h> /* for recv() and send() */
#include <unistd.h>     /* for close() */

#define RCVBUFSIZE 32   /* Size of receive buffer */

void DieWithError(char *errorMessage);  /* Error handling function */

void HandleTCPClient(int clntSocket)
{
    char Buffer[RCVBUFSIZE];        /* Buffer for message string */
    int recvMsgSize;                /* Received message length */

    /* [5.a] RECV: Receive message from client */

    if ((recvMsgSize = recv(clntSocket, Buffer, RCVBUFSIZE, 0)) < 0)
        DieWithError("recv() failed");

    Buffer[recvMsgSize] = '\0';      /* Terminate the string! */
    printf("received string %s.\n", Buffer);

    /* [5.b] SEND: Send back input string and             */
    /*       repeat cycle until end of transmission */

    while (recvMsgSize > 0)      /* zero indicates end of transmission */
    {
        /*  message back to client */
        if (send(clntSocket, Buffer, recvMsgSize, 0) != recvMsgSize)
            DieWithError("send() failed");

        /* See if there is more data to receive */
        if ((recvMsgSize = recv(clntSocket, Buffer, RCVBUFSIZE, 0)) < 0)
            DieWithError("recv() failed");
    }

    /* [6] CLOSE: Close client socket */

    close(clntSocket);    
}
